﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
//
using System.Data.SqlClient;
namespace DBDataReader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        SqlConnection conn;
        SqlCommand cmdSelect;
        SqlDataReader reader;
        SqlCommand cmdUpdate; 

        int ID, Krestni, Prijmeni, Osloveni, Mesto;

        private void btnText_Click(object sender, EventArgs e)
        {
            FillForm();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            conn = new SqlConnection();
            // v praxi nevhodne, lepsi vlozit do konfiguracniho souboru
            // connection string pro SQL server security 
            conn.ConnectionString = "User ID=sa;Password=Pa$$w0rd;Data Source=localhost;Initial Catalog=Northwind";
            // string pro Windows security (Integrated security, Trusted connection ...)
            //conn.ConnectionString = "User Integrated Security=yes;Data Source=localhost;Initial Catalog=Northwind";
            // connection string pro LocalDB 
            //conn.ConnectionString = "User Integrated Security=yes;Data Source=(LocalDB)\\MSSQLSLocalDB;Initial Catalog=Northwind";
            bool bad = false;

            // try/catch pouzit u VSECH operaci s DB
            try { conn.Open(); }
            catch (SqlException ex)
            {
                MessageBox.Show("ADO err: " + ex.Message);
                foreach (SqlError err in ex.Errors)
                {
                    MessageBox.Show("SQL err: " + err.Message);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                bad = true;
            }

            if (bad) return;


            cmdSelect = new SqlCommand();
            cmdSelect.Connection = conn;
            cmdSelect.CommandText = "Select EmployeeID,LastName,FirstName,TitleOfCourtesy,City From Employees";

            cmdUpdate = new SqlCommand();
            cmdUpdate.Connection = conn;

            // datareader je objekt, ktery reprezentuje (zpristupnuje) nacitana data
            reader = cmdSelect.ExecuteReader(); // posle na DB command, ktery vraci data

            ID = reader.GetOrdinal("EmployeeID");
            Krestni = reader.GetOrdinal("FirstName");
            Prijmeni = reader.GetOrdinal("LastName");
            Osloveni = reader.GetOrdinal("TitleOfCourtesy");
            Mesto = reader.GetOrdinal("City");
            FillForm();

        }
        void FillForm()
        {
            // na zacatku stoji DataReader PRED prvnim recordem, metoda Read zpristupni dalsi record
            if ( reader.Read() ) // Read vraci false, pokud jiz dalsi record neexistuje
            {
                // varianta 1 - efektivni ale neprehledna 
                /*
                txtID.Text = reader.GetInt32(0).ToString(); // 0 cislo sloupce v selectu
                txtKrestni.Text = reader.GetString(2);
                txtPrijmeni.Text = reader.GetString(1);
                txtOsloveni.Text = reader.GetString(3);
                txtMesto.Text = reader.GetString(4);
                */
                // varianta 2 - neefektivni, prehledna
                /*txtID.Text = reader["EmployeeID"].ToString(); // 0 cislo sloupce v selectu
                txtKrestni.Text = reader["FirstName"].ToString();
                txtPrijmeni.Text = reader.["LastName"].ToString();
                txtOsloveni.Text = reader.["TitleOfCourtesy"].ToString();
                txtMesto.Text = reader.["City"].ToString();
                 * */
                // varianta 3 - efektivni, prehledna ale pozor na NULL
                /*txtID.Text = reader.GetInt32(ID).ToString();
                txtKrestni.Text = reader.GetString(Krestni);
                txtPrijmeni.Text = reader.GetString(Prijmeni);
                txtOsloveni.Text = reader.GetString(Osloveni);
                txtMesto.Text = reader.GetString(Mesto);*/

                // prace s NULL hodnotami
                txtID.Text = reader[ID].ToString(); // 0 cislo sloupce v selectu
                txtKrestni.Text = reader[Krestni].ToString();
                txtPrijmeni.Text = reader[Prijmeni].ToString();
                txtOsloveni.Text = reader[Osloveni].ToString();
                txtMesto.Text = reader[Mesto].ToString();

            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (reader != null) reader.Close();
            if (conn.State == ConnectionState.Open) conn.Close();
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            string strSql;
            strSql = "Update Employees Set LastName='" + txtPrijmeni.Text + "' Where EmployeeID=" + txtID.Text;

            txtSql.Text = strSql; // debug only

            cmdUpdate.CommandText = strSql;

            // po connection s OTEVRENYM data readerem  NELZE poslat dalsi SQL command
            reader.Close();

            cmdUpdate.ExecuteNonQuery(); // posila na DB command, ktery NEVRACI data (insert,update,create table...) 

            reader = cmdSelect.ExecuteReader();
            FillForm();

        }
    }
}
